<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:ace="http://www.icefaces.org/icefaces/components"
      xmlns:ui="http://java.sun.com/jsf/facelets">

<h:head>
    <title>Лабораторная #{info.VERSION}</title>
    <link href="static/style/style.css" rel="stylesheet"/>
    <link href="static/style/w3.css" rel="stylesheet"/>
</h:head>

<h:body>
    <script>
        let graphics = undefined;
        let selectedR = [ #{formPoint.selectedR} ];
        let points = [ #{formPoint.allPoints} ];
    </script>
    <header>
        <h1 style="margin-top: 5px; margin-bottom: -5px;">
            <button class="w3-btn w3-border-0" id="reload">Попадание в область</button>
        </h1>
        <h:outputText value="#{info.AUTHOR}"/> группа <h:outputText value="#{info.GROUP}"/> <br/>
        Вариант <h:outputText value="#{info.VARIANT}"/>
    </header>

    <article class="work">
        <div class="graphic" style="float: right;">
            <h:form id="canvas-click" >
                <h:inputHidden id="xCanvas" value="#{formPoint.canvasX}" />
                <h:inputHidden id="yCanvas" value="#{formPoint.canvasY}" />
                <canvas id="canvas_1" width="250px" height="250px" />
                <canvas id="canvas_2" width="250px" height="250px" />

                <h:commandScript name="clickCanvas"
                                 execute="@form"
                                 action="#{formPoint.canvasListener}"
                                 render="result-point canvas-new-point" />

                <h:panelGroup id="canvas-new-point">
                    <script type="text/javascript">
                        if(graphics){
                            points = [ #{formPoint.allPoints} ];
                            graphics.drawBackground();
                            graphics.changeGraphicsRadius([ #{formPoint.selectedR} ], [ #{formPoint.allPoints} ]);
                        }
                    </script>
                </h:panelGroup>
            </h:form>
        </div>
        <h:form id="sendD">
            <table border="1px" id="mainForm" style="position: relative; width: 500px;">
                <tr style="height: 45px">
                    <th>Поле</th>
                    <th>Значение</th>
                </tr>
                <tr>
                    <td><h:outputLabel for="X" title="X" value="X" /></td>
                    <td style="height: 30px;">
                        <ace:sliderEntry style="margin-left: auto;margin-right: auto;margin-top: 15px;margin-bottom: -11px;width: 280px;"
                                id="X" length="200px"
                                min="-5" value="#{formPoint.x}" max="5" stepPercent="10"
                                showLabels="true"
                                valueChangeListener="#{formPoint.changeSlider}" >
                            <ace:ajax event="slide" execute="@this" render="X-text submit-btn" />
                        </ace:sliderEntry>
                        <h:outputLabel id="X-text" value="#{formPoint.x}" style="position: relative; top: -15px;" />
                    </td>
                </tr>
                <tr>
                    <td><h:outputLabel for="Y" title="Y" value="Y" /> </td>
                    <td>
                        <h:inputText id="Y"
                                     value="#{formPoint.y}"
                                     required="true"
                                     requiredMessage="Поле является пустым"
                                     validatorMessage="Число вышло за ОДЗ"
                                     converterMessage="Введено не число"
                                     title="от -3 до 5">
                            <f:converter converterId="javax.faces.BigDecimal" />
                            <f:validator validatorId="y-validator" />
                            <f:ajax event="keyup" render="errY submit-btn" />-->
                        </h:inputText>
                        <h:message for="Y" id="errY" styleClass="warn"/>
                    </td>
                </tr>
                <tr>
                    <td><label>R</label></td>
                    <td>
                        <h:selectBooleanCheckbox
                                id="R1" value="#{formPoint.oneR}"
                                label="1" title="1"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="1" value="1" for="R1" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R2" value="#{formPoint.twoR}"
                                label="2" title="2"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="2" value="2" for="R2" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R3" value="#{formPoint.freeR}"
                                label="3" title="3"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="3" value="3" for="R3" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R4" value="#{formPoint.fourR}"
                                label="4" title="4"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="4" value="4" for="R4" style="margin-left: 5px; margin-right: 20px;" />
                        <h:selectBooleanCheckbox
                                id="R5" value="#{formPoint.fiveR}"
                                label="5" title="5"
                                valueChangeListener="#{formPoint.changeBooleanListener}">
                            <f:ajax event="click" render="submit-btn radius-for-canvas"/>
                        </h:selectBooleanCheckbox>
                        <h:outputLabel title="5" value="5" for="R5" style="margin-left: 5px; margin-right: 20px;" />

                        <h:message for="R1" id="errR" styleClass="warn"/>
                        <h:panelGroup id="radius-for-canvas">
                            <script>
                                if(graphics){
                                    graphics.changeGraphicsRadius([ #{formPoint.selectedR} ], [ #{formPoint.allPoints} ]);
                                }
                            </script>
                        </h:panelGroup>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <h:form style="position: relative; top: 45%;">
                            <h:commandButton
                                    styleClass="history-button buttons w3-btn w3-white w3-border w3-border-green w3-round-xlarge"
                                    action="goonmain"
                                    value="Выйти на главное"
                            />
                        </h:form>
                        <h:commandButton id="submit-btn"
                                         styleClass="buttons w3-btn w3-white w3-border w3-border-green w3-round-xlarge"
                                         action="#{formPoint.checkPoint}"
                                         value="Проверить"
                                         disabled="#{!formPoint.readyToSubmit}" >
                            <f:ajax execute="@form" render="send-data result-point" />
                        </h:commandButton>
                        <h:panelGroup id="send-data">
                            <script>
                                if(graphics){
                                    graphics.drawBackground();
                                    graphics.changeGraphicsRadius(selectedR, [ #{formPoint.allPoints} ]);
                                }
                            </script>
                        </h:panelGroup>
                    </td>
                </tr>
            </table>
        </h:form>

        <div id="result-div-table" style="width: 760px; height: 230px; overflow:auto;" >
            <h:dataTable id="result-point"
                    value="#{pointRepo.points}" var="p"
                    styleClass="order-table"
                    headerClass="order-table-header"
                    rowClasses="order-table-odd-row,order-table-even-row">
                <h:column>
                    <f:facet name="header">X</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.x}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">Y</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.y}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">R</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.r}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">Hit</f:facet>
                    <h:panelGroup>
                        <h:outputText value="Undefined" style="color: grey;" rendered="#{p.check == null}"/>
                        <h:outputText value="True" style="color: green;" rendered="#{p.check != null and p.check}" />
                        <h:outputText value="False" style="color: red;" rendered="#{p.check != null and !p.check}" />
                    </h:panelGroup>
                </h:column>
                <h:column>
                    <f:facet name="header">Time</f:facet>
                    <h:panelGroup>
                        <h:outputText value="#{p.time.format(info.dateTimeFormatter)}" />
                    </h:panelGroup>
                </h:column>
            </h:dataTable>
        </div>
    </article>

    <footer>Copyright. All rights reserved. 2019</footer>

    <script src="/static/js/view.js"></script>

    <script>
        graphics.drawBackground();
        graphics.drawArea(selectedR);
        graphics.drawPoint(points);
    </script>
</h:body>
</html>